test-all.sh 15.6 KB
Newer Older
sangshuduo's avatar
sangshuduo 已提交
1 2
#!/bin/bash

3 4 5 6 7 8
# Color setting
RED='\033[0;31m'
GREEN='\033[1;32m'
GREEN_DARK='\033[0;32m'
GREEN_UNDERLINE='\033[4;32m'
NC='\033[0m'
L
liuyq-617 已提交
9

10 11 12
tests_dir=`pwd`
IN_TDINTERNAL="community"

P
Ping Xiao 已提交
13 14
function stopTaosd {
	echo "Stop taosd"
P
Ping Xiao 已提交
15
  sudo systemctl stop taosd
P
Ping Xiao 已提交
16 17 18 19 20 21 22 23 24
  PID=`ps -ef|grep -w taosd | grep -v grep | awk '{print $2}'`
	while [ -n "$PID" ]
	do
    pkill -TERM -x taosd
    sleep 1
  	PID=`ps -ef|grep -w taosd | grep -v grep | awk '{print $2}'`
	done
}

L
liuyq-617 已提交
25 26
function dohavecore(){
  corefile=`find $corepath -mmin 1`  
L
liuyq-617 已提交
27
  core_file=`echo $corefile|cut -d " " -f2`
L
liuyq-617 已提交
28
  proc=`echo $corefile|cut -d "_" -f3`
L
liuyq-617 已提交
29
  if [ -n "$corefile" ];then
30
    echo 'taosd or taos has generated core'
L
fix  
liuyq-617 已提交
31
    rm case.log
L
liuyq-617 已提交
32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47
    if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]] && [[ $1 == 1 ]]; then
      cd ../../../
      tar -zcPf $corepath'taos_'`date "+%Y_%m_%d_%H_%M_%S"`.tar.gz debug/build/bin/taosd debug/build/bin/tsim debug/build/lib/libtaos*so*
      if [[ $2 == 1 ]];then
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S"`
      else
        cd community
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
      fi
    else 
      cd ../../
      if [[ $1 == 1 ]];then 
        tar -zcPf $corepath'taos_'`date "+%Y_%m_%d_%H_%M_%S"`.tar.gz debug/build/bin/taosd debug/build/bin/tsim debug/build/lib/libtaos*so*
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
      fi
    fi
48
    if [[ $1 == 1 ]];then
L
liuyq-617 已提交
49
      echo '\n'|gdb /usr/local/taos/bin/$proc $core_file -ex "bt 10" -ex quit
50 51
      exit 8
    fi
L
liuyq-617 已提交
52
  fi
53
}
L
liuyq-617 已提交
54

55 56
function runSimCaseOneByOne {
  while read -r line; do
P
Ping Xiao 已提交
57
    if [[ $line =~ ^./test.sh* ]] || [[ $line =~ ^run* ]]; then
58
			case=`echo $line | grep sim$ |awk '{print $NF}'`    
P
Ping Xiao 已提交
59
      start_time=`date +%s`      
P
Ping Xiao 已提交
60
      date +%F\ %T | tee -a out.log
L
liuyq-617 已提交
61 62 63
      if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
        echo -n $case
        ./test.sh -f $case > /dev/null 2>&1 && \
L
liuyq-617 已提交
64
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
65 66 67 68 69
        ( grep -q 'script.*success.*m$' ../../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
        echo -e "${RED} failed${NC}" | tee -a out.log
      else
        echo -n $case
        ./test.sh -f $case > /dev/null 2>&1 && \
L
liuyq-617 已提交
70
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
71 72 73
        ( grep -q 'script.*success.*m$' ../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
        echo -e "${RED} failed${NC}" | tee -a out.log
      fi
L
liuyq-617 已提交
74
      out_log=`tail -1 out.log  `
L
liuyq-617 已提交
75 76 77
      # if [[ $out_log =~ 'failed' ]];then
      #   exit 8
      # fi
S
Shuduo Sang 已提交
78 79
      end_time=`date +%s`
      echo execution time of $case was `expr $end_time - $start_time`s. | tee -a out.log
80 81 82
    fi
  done < $1
}
L
liuyq-617 已提交
83
function runSimCaseOneByOnefq {
L
liuyq-617 已提交
84 85 86 87 88

  start=`sed -n "/$1-start/=" jenkins/basic.txt`
  end=`sed -n "/$1-end/=" jenkins/basic.txt`  
  for ((i=$start;i<=$end;i++)) ; do
    line=`sed -n "$i"p jenkins/basic.txt`
L
liuyq-617 已提交
89 90 91
    if [[ $line =~ ^./test.sh* ]] || [[ $line =~ ^run* ]]; then
			case=`echo $line | grep sim$ |awk '{print $NF}'`

92
      start_time=`date +%s`    
P
Ping Xiao 已提交
93
      date +%F\ %T | tee -a out.log
94
      if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
L
liuyq-617 已提交
95
        echo -n $case
L
fix  
liuyq-617 已提交
96
        ./test.sh -f $case > case.log 2>&1 && \
L
liuyq-617 已提交
97
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
98
        ( grep -q 'script.*success.*m$' ../../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
L
fix  
liuyq-617 已提交
99
        ( echo -e "${RED} failed${NC}" | tee -a out.log && echo '=====================log=====================' && cat case.log )
100
      else
L
liuyq-617 已提交
101
        echo -n $case
102
        ./test.sh -f $case > ../../sim/case.log 2>&1 && \
L
liuyq-617 已提交
103
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
104
        ( grep -q 'script.*success.*m$' ../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
L
fix  
liuyq-617 已提交
105
        ( echo -e "${RED} failed${NC}" | tee -a out.log && echo '=====================log=====================' &&  cat case.log )
106 107
      fi
      
L
liuyq-617 已提交
108 109
      out_log=`tail -1 out.log  `
      if [[ $out_log =~ 'failed' ]];then
L
fix  
liuyq-617 已提交
110
        rm case.log
111
        if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
L
liuyq-617 已提交
112
          cp -r ../../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S"`
113
        else 
L
liuyq-617 已提交
114
          cp -r ../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
115
        fi
L
liuyq-617 已提交
116
        dohavecore $2 1
L
fix  
liuyq-617 已提交
117 118 119
        if [[ $2 == 1 ]];then
          exit 8
        fi
L
liuyq-617 已提交
120 121 122
      fi
      end_time=`date +%s`
      echo execution time of $case was `expr $end_time - $start_time`s. | tee -a out.log
L
liuyq-617 已提交
123
      dohavecore $2 1
L
liuyq-617 已提交
124
    fi
L
liuyq-617 已提交
125
  done 
126 127
  rm -rf ../../../sim/case.log
  rm -rf ../../sim/case.log
L
liuyq-617 已提交
128
}
129 130 131 132

function runPyCaseOneByOne {
  while read -r line; do
    if [[ $line =~ ^python.* ]]; then
133
      if [[ $line != *sleep* ]]; then
L
liuyq-617 已提交
134 135 136 137 138 139
        
        if [[ $line =~ '-r' ]];then
          case=`echo $line|awk '{print $4}'`
        else
          case=`echo $line|awk '{print $NF}'`
        fi
S
Shuduo Sang 已提交
140
        start_time=`date +%s`
P
Ping Xiao 已提交
141
        date +%F\ %T | tee -a pytest-out.log
L
liuyq-617 已提交
142
        echo -n $case
143
        $line > /dev/null 2>&1 && \
L
liuyq-617 已提交
144 145
          echo -e "${GREEN} success${NC}" | tee -a pytest-out.log || \
          echo -e "${RED} failed${NC}" | tee -a pytest-out.log
S
Shuduo Sang 已提交
146
        end_time=`date +%s`
L
liuyq-617 已提交
147
        out_log=`tail -1 pytest-out.log  `
L
liuyq-617 已提交
148 149 150
        # if [[ $out_log =~ 'failed' ]];then
        #   exit 8
        # fi
S
Shuduo Sang 已提交
151
        echo execution time of $case was `expr $end_time - $start_time`s. | tee -a pytest-out.log
152 153 154
      else
        $line > /dev/null 2>&1
      fi
155 156 157
    fi
  done < $1
}
L
liuyq-617 已提交
158 159 160 161 162 163 164 165 166 167 168
function runPyCaseOneByOnefq() {
  cd $tests_dir/pytest
  if [[ $1 =~ full ]] ; then
    start=1
    end=`sed -n '$=' fulltest.sh`
  else
    start=`sed -n "/$1-start/=" fulltest.sh`
    end=`sed -n "/$1-end/=" fulltest.sh`
  fi
  for ((i=$start;i<=$end;i++)) ; do
    line=`sed -n "$i"p fulltest.sh`
L
liuyq-617 已提交
169 170 171 172 173 174 175 176 177
    if [[ $line =~ ^python.* ]]; then
      if [[ $line != *sleep* ]]; then
        
        if [[ $line =~ '-r' ]];then
          case=`echo $line|awk '{print $4}'`
        else
          case=`echo $line|awk '{print $NF}'`
        fi
        start_time=`date +%s`
P
Ping Xiao 已提交
178
        date +%F\ %T | tee -a pytest-out.log
L
liuyq-617 已提交
179
        echo -n $case
L
fix  
liuyq-617 已提交
180
        $line > case.log 2>&1 && \
L
liuyq-617 已提交
181
          echo -e "${GREEN} success${NC}" | tee -a pytest-out.log || \
182
          echo -e "${RED} failed${NC}" | tee -a pytest-out.log 
L
liuyq-617 已提交
183 184 185
        end_time=`date +%s`
        out_log=`tail -1 pytest-out.log  `
        if [[ $out_log =~ 'failed' ]];then
L
liuyq-617 已提交
186
          cp -r ../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
L
fix  
liuyq-617 已提交
187
          echo '=====================log===================== '
L
fix  
liuyq-617 已提交
188 189
          cat case.log
          rm -rf case.log
L
liuyq-617 已提交
190
          dohavecore $2 2
L
fix  
liuyq-617 已提交
191 192 193
          if [[ $2 == 1 ]];then
            exit 8
          fi
L
liuyq-617 已提交
194 195 196 197 198
        fi
        echo execution time of $case was `expr $end_time - $start_time`s. | tee -a pytest-out.log
      else
        $line > /dev/null 2>&1
      fi
L
liuyq-617 已提交
199
      dohavecore $2 2
L
liuyq-617 已提交
200
    fi
L
liuyq-617 已提交
201
  done 
202
  rm -rf ../../sim/case.log
L
liuyq-617 已提交
203
}
204

205 206
totalFailed=0
totalPyFailed=0
207
totalJDBCFailed=0
P
Ping Xiao 已提交
208
totalUnitFailed=0
209
totalExampleFailed=0
sangshuduo's avatar
sangshuduo 已提交
210

L
liuyq-617 已提交
211
corepath=`grep -oP '.*(?=core_)' /proc/sys/kernel/core_pattern||grep -oP '.*(?=core-)' /proc/sys/kernel/core_pattern`
212
if [ "$2" != "jdbc" ] && [ "$2" != "python" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ]; then
213
  echo "### run TSIM test case ###"
S
Shuduo Sang 已提交
214
  cd $tests_dir/script
215

216 217 218 219 220 221
  [ -f out.log ] && rm -f out.log
  if [ "$1" == "cron" ]; then
    echo "### run TSIM regression test ###"
    runSimCaseOneByOne regressionSuite.sim
  elif [ "$1" == "full" ]; then
    echo "### run TSIM full test ###"
P
Ping Xiao 已提交
222
    runSimCaseOneByOne jenkins/basic.txt
L
liuyq-617 已提交
223 224
  elif [ "$1" == "b1" ]; then
    echo "### run TSIM b1 test ###"
L
liuyq-617 已提交
225 226 227
    runSimCaseOneByOnefq b1 0
    runSimCaseOneByOnefq b4 0
    runSimCaseOneByOnefq b7 0
L
liuyq-617 已提交
228 229
  elif [ "$1" == "b2" ]; then
    echo "### run TSIM b2 test ###"
L
liuyq-617 已提交
230
    runSimCaseOneByOnefq b2 0
L
balance  
liuyq-617 已提交
231
    runSimCaseOneByOnefq b5 0
L
liuyq-617 已提交
232 233
  elif [ "$1" == "b3" ]; then
    echo "### run TSIM b3 test ###"
L
liuyq-617 已提交
234
    runSimCaseOneByOnefq b3 0
L
balance  
liuyq-617 已提交
235
    runSimCaseOneByOnefq b6 0
L
liuyq-617 已提交
236 237
  elif [ "$1" == "b1fq" ]; then
    echo "### run TSIM b1 test ###"
L
liuyq-617 已提交
238
    runSimCaseOneByOnefq b1 1
L
liuyq-617 已提交
239 240
  elif [ "$1" == "b2fq" ]; then
    echo "### run TSIM b2 test ###"
L
liuyq-617 已提交
241
    runSimCaseOneByOnefq b2 1
L
liuyq-617 已提交
242 243
  elif [ "$1" == "b3fq" ]; then
    echo "### run TSIM b3 test ###"
L
liuyq-617 已提交
244
    runSimCaseOneByOnefq b3 1
L
liuyq-617 已提交
245 246
  elif [ "$1" == "b4fq" ]; then
    echo "### run TSIM b4 test ###"
L
liuyq-617 已提交
247
    runSimCaseOneByOnefq b4 1
L
liuyq-617 已提交
248 249
  elif [ "$1" == "b5fq" ]; then
    echo "### run TSIM b5 test ###"
L
liuyq-617 已提交
250
    runSimCaseOneByOnefq b5 1
L
liuyq-617 已提交
251 252
  elif [ "$1" == "b6fq" ]; then
    echo "### run TSIM b6 test ###"
L
liuyq-617 已提交
253
    runSimCaseOneByOnefq b6 1
L
liuyq-617 已提交
254 255
  elif [ "$1" == "b7fq" ]; then
    echo "### run TSIM b7 test ###"
L
liuyq-617 已提交
256
    runSimCaseOneByOnefq b7 1
S
Shuduo Sang 已提交
257
  elif [ "$1" == "smoke" ] || [ -z "$1" ]; then
258 259 260
    echo "### run TSIM smoke test ###"
    runSimCaseOneByOne basicSuite.sim
  fi
261

262 263
  totalSuccess=`grep 'success' out.log | wc -l`
  totalBasic=`grep success out.log | grep Suite | wc -l`
264

265 266 267
  if [ "$totalSuccess" -gt "0" ]; then
    totalSuccess=`expr $totalSuccess - $totalBasic`
  fi
sangshuduo's avatar
sangshuduo 已提交
268

S
Shuduo Sang 已提交
269
  echo -e "\n${GREEN} ### Total $totalSuccess TSIM case(s) succeed! ### ${NC}"
270

271 272
  totalFailed=`grep 'failed\|fault' out.log | wc -l`
# echo -e "${RED} ### Total $totalFailed TSIM case(s) failed! ### ${NC}"
273

274
  if [ "$totalFailed" -ne "0" ]; then
S
Shuduo Sang 已提交
275
    echo -e "\n${RED} ### Total $totalFailed TSIM case(s) failed! ### ${NC}"
sangshuduo's avatar
sangshuduo 已提交
276

277 278
#  exit $totalFailed
  fi
sangshuduo's avatar
sangshuduo 已提交
279 280
fi

281
if [ "$2" != "sim" ] && [ "$2" != "jdbc" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ]; then
282
  echo "### run Python test case ###"
283

S
Shuduo Sang 已提交
284
  cd $tests_dir
285

S
Shuduo Sang 已提交
286
  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
287 288 289 290 291 292 293 294 295 296 297 298 299 300 301
    cd ../..
  else
    cd ../
  fi

  TOP_DIR=`pwd`
  TAOSLIB_DIR=`find . -name "libtaos.so"|grep -w lib|head -n1`
  if [[ "$TAOSLIB_DIR" == *"$IN_TDINTERNAL"* ]]; then
    LIB_DIR=`find . -name "libtaos.so"|grep -w lib|head -n1|cut -d '/' --fields=2,3,4,5`
  else
    LIB_DIR=`find . -name "libtaos.so"|grep -w lib|head -n1|cut -d '/' --fields=2,3,4`
  fi

  export LD_LIBRARY_PATH=$TOP_DIR/$LIB_DIR:$LD_LIBRARY_PATH

S
Shuduo Sang 已提交
302
  cd $tests_dir/pytest
303 304 305 306 307 308 309 310 311

  [ -f pytest-out.log ] && rm -f pytest-out.log

  if [ "$1" == "cron" ]; then
    echo "### run Python regression test ###"
    runPyCaseOneByOne regressiontest.sh
  elif [ "$1" == "full" ]; then
    echo "### run Python full test ###"
    runPyCaseOneByOne fulltest.sh
L
liuyq-617 已提交
312
  elif [ "$1" == "pytest" ]; then
L
liuyq-617 已提交
313 314
    echo "### run Python full test ###"
    runPyCaseOneByOne fulltest.sh
L
liuyq-617 已提交
315 316
  elif [ "$1" == "pytestfq" ]; then
    echo "### run Python full test ###"
L
liuyq-617 已提交
317
    runPyCaseOneByOnefq full 0
318 319
  elif [ "$1" == "p1" ]; then
    echo "### run Python_1 test ###"
L
liuyq-617 已提交
320
    runPyCaseOneByOnefq p1 1
321 322
  elif [ "$1" == "p2" ]; then
    echo "### run Python_2 test ###"
L
liuyq-617 已提交
323
    runPyCaseOneByOnefq p2 1
L
liuyq-617 已提交
324 325
  elif [ "$1" == "p3" ]; then
    echo "### run Python_3 test ###"
L
liuyq-617 已提交
326
    runPyCaseOneByOnefq p3 1 
L
liuyq-617 已提交
327 328
  elif [ "$1" == "p4" ]; then
    echo "### run Python_4 test ###"
L
liuyq-617 已提交
329
    runPyCaseOneByOnefq p4 1
L
liuyq-617 已提交
330 331
  elif [ "$1" == "b2" ] || [ "$1" == "b3" ]; then
    exit $(($totalFailed + $totalPyFailed))
S
Shuduo Sang 已提交
332
  elif [ "$1" == "smoke" ] || [ -z "$1" ]; then
333 334 335
    echo "### run Python smoke test ###"
    runPyCaseOneByOne smoketest.sh
  fi
336
  totalPySuccess=`grep 'success' pytest-out.log | wc -l`
337 338

  if [ "$totalPySuccess" -gt "0" ]; then
S
Shuduo Sang 已提交
339
    echo -e "\n${GREEN} ### Total $totalPySuccess python case(s) succeed! ### ${NC}"
340 341 342 343
  fi

  totalPyFailed=`grep 'failed\|fault' pytest-out.log | wc -l`
  if [ "$totalPyFailed" -ne "0" ]; then
S
Shuduo Sang 已提交
344
    echo -e "\n${RED} ### Total $totalPyFailed python case(s) failed! ### ${NC}"
345
#  exit $totalPyFailed
346
  fi
sangshuduo's avatar
sangshuduo 已提交
347 348
fi

349

350
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ] && [ "$1" == "full" ]; then
351
  echo "### run JDBC test cases ###"
352

P
Ping Xiao 已提交
353
  cd $tests_dir
354 355 356 357 358 359 360

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

P
Ping Xiao 已提交
361
  pwd
362
  cd debug/
P
change  
Ping Xiao 已提交
363
  
P
Ping Xiao 已提交
364
  stopTaosd
365
  rm -rf /var/lib/taos/*
366 367
  nohup build/bin/taosd -c /etc/taos/ > /dev/null 2>&1 &
  sleep 30
P
change  
Ping Xiao 已提交
368
  
369
  cd $tests_dir/../src/connector/jdbc  
P
Ping Xiao 已提交
370
  
P
change  
Ping Xiao 已提交
371
  mvn test > jdbc-out.log 2>&1
372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393
  tail -n 20 jdbc-out.log

  cases=`grep 'Tests run' jdbc-out.log | awk 'END{print $3}'`
  totalJDBCCases=`echo ${cases/%,}`
  failed=`grep 'Tests run' jdbc-out.log | awk 'END{print $5}'`
  JDBCFailed=`echo ${failed/%,}`
  error=`grep 'Tests run' jdbc-out.log | awk 'END{print $7}'`
  JDBCError=`echo ${error/%,}`
  
  totalJDBCFailed=`expr $JDBCFailed + $JDBCError`
  totalJDBCSuccess=`expr $totalJDBCCases - $totalJDBCFailed`

  if [ "$totalJDBCSuccess" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalJDBCSuccess JDBC case(s) succeed! ### ${NC}"
  fi
  
  if [ "$totalJDBCFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalJDBCFailed JDBC case(s) failed! ### ${NC}"
  fi
  dohavecore 1
fi

394
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "jdbc" ]  && [ "$2" != "example" ]  && [ "$1" == "full" ]; then
395 396 397 398 399 400 401 402 403 404 405 406 407
  echo "### run Unit tests ###"  

  stopTaosd
  cd $tests_dir

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

  pwd
  cd debug/build/bin
408
  rm -rf /var/lib/taos/*
409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429
  nohup ./taosd -c /etc/taos/ > /dev/null 2>&1 &
  sleep 30
  
  pwd
  ./queryTest > unittest-out.log 2>&1
  tail -n 20 unittest-out.log

  totalUnitTests=`grep "Running" unittest-out.log | awk '{print $3}'`  
  totalUnitSuccess=`grep 'PASSED' unittest-out.log | awk '{print $4}'`
  totalUnitFailed=`expr $totalUnitTests - $totalUnitSuccess`

  if [ "$totalUnitSuccess" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalUnitSuccess Unit test succeed! ### ${NC}"
  fi
  
  if [ "$totalUnitFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalUnitFailed Unit test failed! ### ${NC}"
  fi
  dohavecore 1
fi

430 431
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "jdbc" ] && [ "$2" != "unit" ] && [ "$1" == "full" ]; then
  echo "### run Example tests ###"  
432

433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459
  stopTaosd
  cd $tests_dir

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

  pwd
  cd debug/build/bin
  rm -rf /var/lib/taos/*
  nohup ./taosd -c /etc/taos/ > /dev/null 2>&1 &
  echo "sleeping for 30 seconds"
  #sleep 30
  
  cd $tests_dir
  echo "current dir: "
  pwd
  cd examples/c
  echo "building applications"
  make > /dev/null
  totalExamplePass=0

  echo "Running tests"
  ./apitest > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
460
    echo "apitest failed"
461 462
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
463
    echo "apitest pass"
464 465 466 467 468 469 470 471 472 473 474 475 476 477
    totalExamplePass=`expr $totalExamplePass + 1`
  fi 

  ./prepare 127.0.0.1 > /dev/null 2>&1
  if [ $? != "0" ]; then
    echo "prepare failed"
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
    echo "prepare pass"
    totalExamplePass=`expr $totalExamplePass + 1`
  fi

  ./subscribe -test > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
478
    echo "subscribe failed"
479 480
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
481
    echo "subscribe pass"
482 483 484 485 486
    totalExamplePass=`expr $totalExamplePass + 1`
  fi

  yes |./asyncdemo 127.0.0.1 test 1000 10 > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
487
    echo "asyncdemo failed"
488 489
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
490
    echo "asyncdemo pass"
491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506
    totalExamplePass=`expr $totalExamplePass + 1`
  fi
  
  if [ "$totalExamplePass" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalExamplePass examples succeed! ### ${NC}"
  fi
  
  if [ "$totalExampleFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalExampleFailed examples failed! ### ${NC}"
  fi

  dohavecore 1
fi


exit $(($totalFailed + $totalPyFailed + $totalJDBCFailed + $totalUnitFailed + $totalExampleFailed))